<?php

class RP_Facts_Panel_Creator {

    /**
     *
     * @param array $facts
     * @param array $options
     * @return string
     */
	public static function create( $facts, $options ) {
		$block = '<section class="rp_truncate">';
        $block .= RP_Persona_Helper::get_banner($options, __( 'Facts', 'rootspersona' ));
		$block .= '<div class="rp_facts">';
		$block .= '<ul>';
		$cnt = count( $facts );
		for ( $idx = 0; $idx < $cnt; $idx++ ) {
            if((!isset($facts[$idx]['classification']) 
                    || empty($facts[$idx]['classification']))
               && ($options['hide_dates'] 
                    || !isset($facts[$idx]['date']) 
                    || empty($facts[$idx]['date'])))
                continue;  // no real meaningfull data, so skip it
			$block .= '<li>';
			if ( ! $options['hide_dates']
			&& isset( $facts[$idx]['date'] )
			&& ! empty( $facts[$idx]['date'] ) ) {
				$block .= @preg_replace( '/@.*@(.*)/US', '$1', $facts[$idx]['date'] ) . ' - ';
			}
			$block .= $facts[$idx]['type'] . ' - ' . $facts[$idx]['classification'];
			if ( ! $options['hide_places']
			&& isset( $facts[$idx]['place'] )
			&& ! empty( $facts[$idx]['place'] ) ) {
				$block .= '; <span class="rp_place">' . $facts[$idx]['place'] . '</span>';
			}
			$p = $facts[$idx]['associated_person'];
			if ( isset( $p )
			&& ! empty( $p ) ) {
				$block .= ' ' . __( 'with', 'rootspersona' ) . ' ' . $p['name'];
			}
			$block .= '</li>';
		}
		$block .= '</ul></div></section>';
		return $block;
	}
}
?>
